OpenGL-3.0.3.0: A binding for the OpenGL graphics system

Copyright | (c) Sven Panne 2002-2019
License | BSD3
Maintainer | Sven Panne <svenpanne@gmail.com>
Stability | stable
Portability | portable
Safe Haskell | None
Language | Haskell2010

Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap

Description

This module corresponds to a part of section 3.6.1 (Pixel Storage Modes) of the OpenGL 2.1 specs.

Synopsis

- data PixelMapTarget
  - = IToI
  - | SToS
  - | IToR
  - | IToG
  - | IToB
  - | IToA
  - | RToR
  - | GToG
  - | BToB
  - | AToA
- class Storable c => PixelMapComponent c
- class PixelMap (m :: Type -> Type) where
  - withNewPixelMap :: PixelMapComponent c => Int -> (Ptr c -> IO ()) -> IO (m c)
  - withPixelMap :: PixelMapComponent c => m c -> (Int -> Ptr c -> IO a) -> IO a
  - newPixelMap :: PixelMapComponent c => [c] -> IO (m c)
  - getPixelMapComponents :: PixelMapComponent c => m c -> IO [c]
- data GLpixelmap a
- maxPixelMapTable :: GettableStateVar GLsizei
- pixelMap :: (PixelMap m, PixelMapComponent c) => PixelMapTarget -> StateVar (m c)
- pixelMapIToRGBA :: PixelMapComponent c => StateVar [Color4 c]
- pixelMapRGBAToRGBA :: PixelMapComponent c => StateVar [Color4 c]

# Documentation

data PixelMapTarget Source #

Constructors

IToI |
SToS |
IToR |
IToG |
IToB |
IToA |
RToR |
GToG |
BToB |
AToA |

#### Instances

Instances details

Show PixelMapTarget Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods showsPrec :: Int -> PixelMapTarget -> ShowS Source # show :: PixelMapTarget -> String Source # showList :: [PixelMapTarget] -> ShowS Source #
Eq PixelMapTarget Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods (==) :: PixelMapTarget -> PixelMapTarget -> Bool Source # (/=) :: PixelMapTarget -> PixelMapTarget -> Bool Source #
Ord PixelMapTarget Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap

Methods

compare :: PixelMapTarget -> PixelMapTarget -> Ordering Source #

(<) :: PixelMapTarget -> PixelMapTarget -> Bool Source #

(<=) :: PixelMapTarget -> PixelMapTarget -> Bool Source #

(>) :: PixelMapTarget -> PixelMapTarget -> Bool Source #

(>=) :: PixelMapTarget -> PixelMapTarget -> Bool Source #

max :: PixelMapTarget -> PixelMapTarget -> PixelMapTarget Source #

min :: PixelMapTarget -> PixelMapTarget -> PixelMapTarget Source #

class Storable c => PixelMapComponent c Source #

Minimal complete definition

getPixelMapv, pixelMapv

#### Instances

Instances details

PixelMapComponent GLfloat Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods getPixelMapv :: GLenum -> Ptr GLfloat -> IO () pixelMapv :: GLenum -> GLsizei -> Ptr GLfloat -> IO ()
PixelMapComponent GLuint Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods getPixelMapv :: GLenum -> Ptr GLuint -> IO () pixelMapv :: GLenum -> GLsizei -> Ptr GLuint -> IO ()
PixelMapComponent GLushort Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods getPixelMapv :: GLenum -> Ptr GLushort -> IO () pixelMapv :: GLenum -> GLsizei -> Ptr GLushort -> IO ()

class PixelMap (m :: Type -> Type) where Source #

Minimal complete definition

Nothing

Methods

withNewPixelMap :: PixelMapComponent c => Int -> (Ptr c -> IO ()) -> IO (m c) Source #

withPixelMap :: PixelMapComponent c => m c -> (Int -> Ptr c -> IO a) -> IO a Source #

newPixelMap :: PixelMapComponent c => [c] -> IO (m c) Source #

getPixelMapComponents :: PixelMapComponent c => m c -> IO [c] Source #

#### Instances

Instances details

PixelMap GLpixelmap Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap

Methods

withNewPixelMap :: PixelMapComponent c => Int -> (Ptr c -> IO ()) -> IO (GLpixelmap c) Source #

withPixelMap :: PixelMapComponent c => GLpixelmap c -> (Int -> Ptr c -> IO a) -> IO a Source #

newPixelMap :: PixelMapComponent c => [c] -> IO (GLpixelmap c) Source #

getPixelMapComponents :: PixelMapComponent c => GLpixelmap c -> IO [c] Source #

data GLpixelmap a Source #

#### Instances

Instances details

PixelMap GLpixelmap Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap

Methods

withNewPixelMap :: PixelMapComponent c => Int -> (Ptr c -> IO ()) -> IO (GLpixelmap c) Source #

withPixelMap :: PixelMapComponent c => GLpixelmap c -> (Int -> Ptr c -> IO a) -> IO a Source #

newPixelMap :: PixelMapComponent c => [c] -> IO (GLpixelmap c) Source #

getPixelMapComponents :: PixelMapComponent c => GLpixelmap c -> IO [c] Source #

Show (GLpixelmap a) Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods showsPrec :: Int -> GLpixelmap a -> ShowS Source # show :: GLpixelmap a -> String Source # showList :: [GLpixelmap a] -> ShowS Source #
Eq (GLpixelmap a) Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap Methods (==) :: GLpixelmap a -> GLpixelmap a -> Bool Source # (/=) :: GLpixelmap a -> GLpixelmap a -> Bool Source #
Ord (GLpixelmap a) Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.PixelRectangles.PixelMap

Methods

compare :: GLpixelmap a -> GLpixelmap a -> Ordering Source #

(<) :: GLpixelmap a -> GLpixelmap a -> Bool Source #

(<=) :: GLpixelmap a -> GLpixelmap a -> Bool Source #

(>) :: GLpixelmap a -> GLpixelmap a -> Bool Source #

(>=) :: GLpixelmap a -> GLpixelmap a -> Bool Source #

max :: GLpixelmap a -> GLpixelmap a -> GLpixelmap a Source #

min :: GLpixelmap a -> GLpixelmap a -> GLpixelmap a Source #

maxPixelMapTable :: GettableStateVar GLsizei Source #

pixelMap :: (PixelMap m, PixelMapComponent c) => PixelMapTarget -> StateVar (m c) Source #

pixelMapIToRGBA :: PixelMapComponent c => StateVar [Color4 c] Source #

Convenience state variable

pixelMapRGBAToRGBA :: PixelMapComponent c => StateVar [Color4 c] Source #

Convenience state variable